#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>

#define FIFO "/tmp/fifo.server"

int main() {
	int n,pid=getpid();
	int serv_lit, clie_lit;
	mode_t fifo_flg = S_IRUSR | S_IWUSR;
	int MAX=150;
	char buf[MAX],str[MAX];
	char FIFO_cli[20];

        /* creation de la fifo du client */
	sprintf(FIFO_cli,"/tmp/fifo.%d",pid);
	printf("Tentative de creation de %s\n",FIFO_cli);
        if ((mkfifo(FIFO_cli,fifo_flg)<0 ) && (errno !=EEXIST)) {
                perror("mkfifo");
                exit(EXIT_FAILURE);
        }

	/* ouverture de la fifo du serveur */
	if ((serv_lit=open(FIFO,O_WRONLY,0))<0 ) {
		perror("open");
		exit(EXIT_FAILURE);
	}
	printf("Ouverture /tmp/fifo.server ok \n");

	n=sprintf(buf,"%d,%d was here!",getpid(),getpid());
	printf(">%s< dans buf\n",buf);
	write(serv_lit,buf,n);

	if ((clie_lit=open(FIFO_cli,O_RDONLY,0))<0 ) {
		perror("open");
		exit(EXIT_FAILURE);
	}
	printf("Ouverture /tmp/fifo.%d ok \n",pid);

	
	n=read(clie_lit,buf,MAX);
	
	close(serv_lit);
	close(clie_lit);
	if (unlink(FIFO_cli)<0) perror("unlink:");
	exit(EXIT_SUCCESS);
}

