#include <stdio.h> 	/* pour printf              */
#include <stdlib.h>	/* pour exit                */ 
#include <unistd.h> 	/* pour fork, sleep, getpid */
#include <sys/types.h>	/* pour fork, wait,  getpid */
#include <sys/wait.h>	/* pour wait                */
#include <errno.h>	/* pour perror              */

int main(){ 
	int pid ; 
	int VAR=14;
	int StatusFils=3;
	pid_t Val_wait;

	pid = fork() ;          /* Creation de la copie du processus courant */
	if (pid < 0) {          /* Si fork() a echoue */
		perror("fork");
	 	return -1 ;     /* on sort */
	} 
	
	printf("%5d > J'ai le pid %d. Mon pere a le pid %d.\n",getpid(),getpid(),getppid()); 
	printf("%5d > La valeur pour ma variable VAR est %d.\n",getpid(),VAR);

	if (pid == 0) {         /* Si on est dans le processus fils ... */
		VAR++;
		sleep(1);       /* s'endord pour 1 seconde*/
		printf("%5d > J'incremente VAR et sa valeur devient %d.\n",getpid(),VAR);
	}
	else{                   /* Si on est dans le pere */
		printf("%5d > J'attends le signal de fin de mon fils.\n",getpid());
		if ((Val_wait=wait(&StatusFils))!=pid) perror("wait");
		printf("%5d > J'ai recu du processus %d la valeur %d.\n",getpid(),Val_wait,StatusFils);
		printf("%5d > Ma valeur de VAR est %d.\n",getpid(),VAR);
	} 

	exit(EXIT_SUCCESS);
}
