#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>

#define TAILLE_MSG 48

struct tampon {
	long int mtype;
	char mtext[TAILLE_MSG];
	};

int main(){
	int msqid;
	key_t clef;
	struct tampon resultat;
	int secondes=0;
	int msgflg = IPC_CREAT | 0600;		/* option de creation de la file */

	clef = ftok(getenv("HOME"),(char) 3); 	/* generation de ma clef de file de message */
	if ((msqid = msgget(clef, msgflg))<0) { /* generation de la file */
		perror("msgget");
		exit(EXIT_FAILURE);
	}
	else printf("%d > ok pour la creation de la file %d.\n",getpid(),msqid);

	while(secondes<=10) {
		if ( (msgrcv(msqid,&resultat,TAILLE_MSG,1L,IPC_NOWAIT))<0 )
			perror("msgrcv");
		else {
			printf("Le message recu au bout de %d secondes est: %s\n",secondes,resultat.mtext);
			break;
		}
		sleep(1);
		secondes++;
	}

	if ((msgctl(msqid,IPC_RMID,(struct msqid_ds *)NULL))<0) {
		perror("msgctl");
	}

	exit(EXIT_SUCCESS);
}


