#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>

int main(){
	int semid;
	key_t clef;
	int semflg_ini= IPC_CREAT | 0600 ;	/* option de creation  du   tableau */
	int semflg_fin= IPC_RMID;		/* option de destruction du tableau */
	int nsems=1;				/* nombre de semaphores du  tableau */
	int i;
	ushort array[nsems];
	ushort array2[nsems];
	struct sembuf operation[nsems];

	clef = ftok(getenv("HOME"),(char) 5); 	/* generation de ma clef de file de message */
	if ((semid = semget(clef, nsems, semflg_ini))<0) { /* generation de la file */
		perror("semget");
		exit(EXIT_FAILURE);
	}
	else printf("%d > ok pour la creation du tableaux de semaphores %d.\n",getpid(),semid);


	if (semctl(semid,0,SETVAL,0)<0) perror("semctl");     /* initialisation individuelle */
	
	/* preparation du tableau d'operations */
	operation[0].sem_num= 0;
	operation[0].sem_op = -1;
	operation[0].sem_flg= 0;

	printf("J'attends l'execution de MIAG_sem_1_2.o pour terminer mon execution.\n");

	/* application du tableau d'operation */
	if (semop(semid,operation,1)!=0) {
		perror("semop");
		if ((semctl(semid,5,IPC_RMID,NULL))<0) {/* suppression du tableau de semaphores */
			perror("msgctl");}
		exit(EXIT_FAILURE);
	}	

	printf("Je suis libere par MIAG_sem_1_2.o.\n");
	if ((semctl(semid,5,IPC_RMID,NULL))<0) {/* suppression du tableau de semaphores */
		perror("msgctl");
		exit(EXIT_FAILURE);
	}

	exit(EXIT_SUCCESS);
}
